Attribute VB_Name = "APIStuff"
Option Explicit

Public OldWindowProc As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
' Process messages.
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Const HTCAPTION = 2
Const WM_NCLBUTTONDOWN = &HA1

    ' If we're being destroyed,
    ' restore the original WindowProc.
    If msg = WM_NCDESTROY Then
        SetWindowLong _
            hwnd, GWL_WNDPROC, _
            OldWindowProc
    End If

    ' See if this is WM_NCLBUTTONDOWN.
    If msg = WM_NCLBUTTONDOWN Then
        ' This is WM_NCLBUTTONDOWN. See if we
        ' clicked in the caption area.
        If wParam = HTCAPTION Then
            ' This is in the caption area.
            ' Restore the form.
            Form1.Restore
        End If
    End If

    ' Call the original WindowProc.
    NewWindowProc = CallWindowProc( _
        OldWindowProc, hwnd, msg, wParam, _
        lParam)
End Function
